module Program(Type, FSymInfo,DataDefinition(..), SigList,Defs,Cons,
   FunctionDefinition(..), FunctionalProg, ProgInfo(..), equations) where

import Term

type Type = String

type FSymInfo = ([Type], Type)
data DataDefinition = Data Type [(FSym, FSymInfo)] deriving Show

type SigList = [(FSym, FSymInfo)]
type Defs = SigList
type Cons = SigList

data FunctionDefinition = Function FSym FSymInfo [(Term,Term)] deriving Show
type FunctionalProg = ([DataDefinition],[FunctionDefinition])

data ProgInfo = ProgInfo [Type] Cons Defs Equations

instance Show ProgInfo where
  show (ProgInfo tys cons defs eqs) = unlines $
    ["types:"] ++ tys ++ [""] ++
    ["constructors:"] ++ map showty cons ++ [""] ++
    ["defined symbols:"] ++ map showty defs ++ [""] ++
    ["equations:"] ++ map (\(l,r) -> show l ++ " = " ++ show r) eqs
   where showty (f, (inp,out)) = f ++ " :: " ++ show inp ++ " -> " ++ show out

equations :: ProgInfo -> Equations
equations (ProgInfo _ _ _ eqs) = eqs
