module Term(Term(..), Var, FSym, Subst, applySubst, Equations) where

type Var  = String
type FSym = String

data Term = 
  Var Var 
  | Fun FSym [Term]
  deriving Eq
  
type Equations = [(Term,Term)]


commas [] = ""
commas [x] = x
commas (x : xs) = x ++ "," ++ commas xs  
  
instance Show Term where
  show (Var x) = x
  show (Fun f []) = f
  show (Fun f ts) = f ++ "(" ++ commas (map show ts) ++ ")"


type Subst = Var -> Term

applySubst :: Subst -> Term -> Term
applySubst sig (Var x) = sig x
applySubst sig (Fun f ts) = Fun f (map (applySubst sig) ts)
